#include "PointCloud.h"

#include <algorithm>>

using namespace std;

PointCloud::PointCloud(Point* data, int count) : m_pData(data)
											   , m_count(count)
{
}

PointCloud::~PointCloud()
{
	delete[] m_pData;
}

struct PointSorter
{
	PointSorter(float x, float y, float z) : m_x(x), m_y(y), m_z(z) {}

	// returns the distance from camera to a point
	inline float Distance(const Point& p) const
	{
		float vx = p.x-m_x;
		float vy = p.y-m_y;
		float vz = p.z-m_z;

		return vx*vx+vy*vy+vz*vz;
	}

	// want to sort in reverse order for drawing
	inline bool operator()(const Point& lhs, const Point& rhs) const
	{
		return Distance(lhs) > Distance(rhs);			
	}

	float m_x;
	float m_y;
	float m_z;
};

void PointCloud::Sort(float ex, float ey, float ez)
{
	sort(m_pData, m_pData+m_count, PointSorter(ex, ey, ez));
}
