#pragma once

struct Point
{
	float x;
	float y;
	float z;
	int intensity;
};


class PointCloud
{
	PointCloud(const PointCloud&);
	PointCloud& operator=(const PointCloud&);

public:

	PointCloud(Point* data, int count);
	~PointCloud();

	// sort points with respect to eye position
	void Sort(float ex, float ey, float ez);

	const Point* GetPoints() const
	{
		return m_pData;
	}

	int GetNumPoints() const
	{
		return m_count;
	}

private:

	Point* m_pData;
	int m_count;
};