#pragma once

#include <cstddef>

//! generic byte data
typedef unsigned char	byte;

//! unsigned types
typedef unsigned char	uchar;
typedef unsigned short	ushort;
typedef unsigned int	uint;
typedef unsigned long	ulong;

//! an unsigned integer type large enough to hold a pointer
typedef uint		intptr;
typedef uint		uintptr;
typedef uint		ptrdiff;

#ifdef WIN32

typedef signed char int8;
typedef short int16;
typedef long int32;
typedef __int64 int64;
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned long uint32;
typedef unsigned __int64 uint64;

#else // For LINUX and MAC_TIGER

typedef signed char int8;
typedef short int16;
typedef long int32;
typedef long long int64;
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned long uint32;
typedef unsigned long long uint64;

#endif

#include <string>
#include <sstream>

#ifdef UNICODE

typedef wchar_t			tchar;
typedef std::wstring	tstring;
typedef std::wstringstream tstringstream;

#define _TS(x) L ## x

#else

typedef char			tchar;
typedef std::string		tstring;
typedef std::stringstream tstringstream;

#define _TS(x) x

#endif
